import { Camera, Component, EventTouch, Node, Vec2, Vec3, _decorator, game } from 'cc';

const { ccclass, property } = _decorator;

const __vec2_temp1 = new Vec2()
const __vec2_temp2 = new Vec2()
const __vec3_temp1 = new Vec3()

@ccclass('GuideInRectDemo')
export class GuideInRectDemo extends Component {
    @property(Camera)
    readonly camera: Camera;
    @property(Node)
    readonly dragOperation: Node;
    @property(Node)
    readonly localPlayer: Node;

    onLoad() {
        // this.dragOperation.on(Node.EventType.TOUCH_START, this.touchStart, this);
        this.dragOperation.on(Node.EventType.TOUCH_MOVE, this.touchMove, this);
        // this.dragOperation.on(Node.EventType.TOUCH_END, this.touchEnd, this);
        // this.dragOperation.on(Node.EventType.TOUCH_CANCEL, this.touchEnd, this);
    }

    protected touchStart(event: EventTouch): void {

    }
    protected touchMove(event: EventTouch): void {
        let startLocation = event.getUIStartLocation(__vec2_temp1);
        let currentLocation = event.getUILocation(__vec2_temp2);
        let dir = Vec2.subtract(__vec2_temp1, currentLocation, startLocation);
        let distance = dir.length();
        if (distance == 0) return;
        // direction.multiplyScalar(Math.min(1, distance / 100) / distance);

        const rotation = this.camera.node.worldRotation;
        const direction = Vec3.transformQuat(__vec3_temp1, __vec3_temp1.set(dir.x, 0, -dir.y), rotation);
        direction.y = 0;
        direction.normalize();
        direction.multiplyScalar(4 * game.deltaTime);
        this.localPlayer.position = this.localPlayer.position.add(direction);
    }
    protected touchEnd(event: EventTouch): void {

    }
}

