import { _decorator, AssetManager, assetManager, Component, Node, warn } from 'cc';
const { ccclass, property } = _decorator;

/**
 * https://forum.cocos.org/t/topic/154597
 */

@ccclass('BundleNameBug')
export class BundleNameBug extends Component {
    private static _bundleName: string = "presets";
    public static get presetBundleName(): string { return BundleNameBug._bundleName; }
    private static _bundle: AssetManager.Bundle;
    public static get bundle() { return BundleNameBug._bundle; }
    // private static _presets: Presets;
    // public static get presets() { return BundleNameBug._presets; }

    public static async init() {
        BundleNameBug._bundle = await new Promise<AssetManager.Bundle>(resolve => assetManager.loadBundle(BundleNameBug.presetBundleName, (error: Error | null, data: AssetManager.Bundle) => {
            if (error != null) return warn(error);
            resolve(data);
        }));

        BundleNameBug.registerPipeline();
    }

    private static replacePresetAsset(task: AssetManager.Task) {
        const input = task.output = task.input;
        // const bundle = PresetConfigManager.bundle;
        // const presets = PresetConfigManager.presets;
        // const presetBundleName = "presets";
        for (let i = 0; i < input.length; i++) {
            const item = input[i] as AssetManager.RequestItem & { config: any, overrideUuid: string };
            // const config = item.config;
            if(item.uuid.startsWith("f3c36b7f-2868-43ce-88a4-b8c51f51e432")) {
                console.log("这个是presets bundle的资源，但是config中的name却显示的是resources bundle的。", item.config.name, item);
            }
            // if (config == null || config.name != BundleNameBug.presetBundleName) continue;
            // // @ts-ignore
            // const path: string = item.info?.path;
            // if (path == null) continue;

            // const dirnames = path.split("/");
            // if (dirnames.length < 2) continue;
            // const preset = presets[dirnames[0]];
            // if (preset == null || preset.value == dirnames[1])
            //     continue;

            // const newPath = path.replace(dirnames[1], preset.value);
            // const info = bundle.getInfoWithPath(newPath);
            // if (info == null) return console.warn(`preset asset ${newPath} is not exist.`)

            // item.info = info;
            // item.overrideUuid = info.uuid;
        }
    }

    protected static registerPipeline(): void {
        assetManager.transformPipeline.insert(BundleNameBug.replacePresetAsset, 2);
    }
}

